.TH m.svfit
.SH NAME
\fIm.svfit\fR \- Semivariogram model fitting.
.br
.I (GRASS Data Import/Processing Program)
.SH SYNOPSIS
\fBm.svfit\fR
.br
\fBm.svfit help\fR
.br
\fBm.svfit \fR[\fB-pqw\fR] 
[\fBinput\*=\fIname\fR]
\fBmodel\*=\fIvalue\fR 
\fBrange\*=\fIvalue\fR
[\fBgraph\*=\fIname\fR] 
.SH DESCRIPTION
.I m.svfit
calculates a sample semivariogram and either plots
it in the GRASS graphics window
or writes the estimated parameters to standard output, or
both.
.LP
For more information, refer to the tutorial or see
the example below.
.LP
\fBFlags:\fR
.IP \fB-q\fR 18
Quiet. Cut out the chatter.
.IP \fB-p\fR 18
Plot model & sample semivariogram (requires \fIg.gnuplot\fR).
.IP \fB-w\fR 18
Use weighted least squares (default is general least squares)
.LP
\fBParameters:\fR
.IP \fBsites\*=\fIname\fR 18
UNIX file containing sample semivariogram (see NOTES).
Default is standard input.
.IP \fBmodel\*=\fIvalue\fR 18
Integer Model Index, one of 
.br
1 (Linear), 
.br
2 (Spherical),
.br
3 (Exponential),
.br
4 (Gaussian),
.br
5 (Quadratic), or
.br
6 (Wave or Hole Effect).
.IP \fBrange\*=\fIvalue\fR 18
Range of semivariogram.
.IP \fBgraph\*=\fIname\fR 18
Basename to save graphing data/commands files.
Graphs are saved in the current working directory with
the extensions \fI.gp\fR and \fI.dat\fR. Implies
the \fB-p\fR flag. 
.LP
.SH NOTES
Three columns of
data are expected as input: lag distance (\fIh\fR),
semivariogram value (\fIgamma\fR), and the number of data pairs
used to compute it (\fIN(h)\fR). This may either be from
a UNIX file, entered from the command line (terminated by control-d),
or via a pipe or redirection.
.LP
.SH EXAMPLE
.I m.svfit
was designed to be used in conjunction with
.I s.sv,
a GRASS sites program for calculating sample
semivariograms. The following example calculates
a sample semivariogram of the sites list
.I wells
with a nominal lag distance
of 5 and then fits a linear model with a range of 100.
The sample semivariogram and model are plotted in
the GRASS graphics monitor and the graphing instructions
and data are saved to files with the basename
.I svwells
in the current working directory:
.LP
.RS
\fBs.sv -q wells lag=5 | m.svfit -p m=1 r=100 g=svwells
.RE
.LP
By saving the graphing instructions and data, the
semivariogram may be plotted again later by
the following command:
.LP
.RS
\fBg.gnuplot svwells.gp
.RE
.LP
.SH SEE ALSO
.I s.univar,
.I s.normal,
.I g.gnuplot,
.I s.sv 
and
.br
.I Semivariogram Modeling \-
A GRASS Tutorial on Exploratory
Data Analysis and Semivariogram Modeling (in preparation).
.SH BUGS
.LP
Please send all bug fixes and comments to the author.
.SH AUTHOR
James Darrell McCauley, Purdue University 
.if n .br 
(mccauley@ecn.purdue.edu)
