.TH r.proj
.SH NAME
.\" comment
\fIr.proj\fR \- projection conversion of a raster map.
.br
.I (GRASS Raster Program)
.SH SYNOPSIS
\fBr.proj\fR
.br
\fBr.proj help\fR
.br
\fBr.proj \fR[\fB-B|C\fR] \fB-m \fIsource_map\fR \fB-l \fIsource_location\fR 
[\fB-o \fItarget_map\fR] [\fB-s \fIsource_mapset\fR] [\fB-d \fIsource_gisdbase\fR] 
.SH DESCRIPTION
.I r.proj
allows a user to convert a raster map in a specified mapset of a 
specified location (different from current) with the projection of this
source location, to a raster map in the current mapset of a target 
location with the projection of this target location.  Both projections 
are defined in PROJ_INFO files in the PERMANENT directories of the 
respective locations.  
.LP
The size and resolution of the target map are controlled by the current 
region, as set using g.region.  
.LP
\fIr.proj\fR creates the correct cellhd file, and copies the cats and colr files 
from the source mapset.  
.SH OPTIONS
\fBFlags:\fR
.IP \fB-B|C\fR 18
Local interpolation method used: B=bilinear, C=cubic, default=nearest neighbour.  
.LP
\fBParameters:\fR
.IP \fB-m\ \fIsource_map\fR 18
Name of input raster map.  
.LP
.IP \fB-l\ \fIsource_location\fR 18
Name of location containing input raster map.  
.LP
.IP \fB-o\ \fItarget_map\fR 18
Name of output raster map (default=source_map).  
.LP
.IP \fB-s\ \fIsource_mapset\fR 18
Name of mapset containing input raster map (default=same as current mapset).  
.LP
.IP \fB-d\ \fIsource_gisdbase\fR 18
Name of database containing input location (default=current gisdbase).  
.SH NOTES
This is implemented as a Bourne shell script, which calls r.stats (GRASS main), 
the PROJ program (Gerry Evenden), and s.sample (Darrell McCauley), 
so all these programs need to installed and running in order for r.proj to work.   
.LP
.SH SEE ALSO
.I v.proj,
.I g.setproj,
.I PROJ4.0,
.I s.sample,
.I g.region
.SH BUGS
Only tested for a few projections.  Uses a very large temporary ascii file.  
The s.sample step does not scale well;  this part needs to be rewritten 
by sorting the site-list according to the y coordinate, and then keeping rows 
of the source map in buffers to cut down the number of get_row calls 
which are quite expensive.  
.LP
Please send all bug fixes and comments to the author.
.SH AUTHOR
Simon Cox, AGCRC, CSIRO Exploration & Mining
.if n .br 
(simon@ned.dem.csiro.au)
