.\" %W% %G%
.TH r.direct   
.SH NAME
r.direct \- Generates a flow direction map from a given elevation layer 
.SH DESCRIPTION
.B r.direct
	The command format is:

r.direct input=elev_map output=flow_direction_map type=agnps (answers or grass)

.nf
input=map		elevation map
output=map	flow direction map
type=text		type of flow direction map to be created
.fi

.SH EXAMPLE
r.direct input=ansi.elev output=ansi.asp type=grass

.RS
will create a flow direction map ansi.asp for the type grass 
.RE
.SH ATTENTION
.I The type
is the type of format for which the user wishes to create the flow direction
map. The \fIagnps\fR format gives category values from 1-8, with 1 facing north
and increasing values in the
clockwise direction. The \fIanswers\fR format gives category values from 0-360 degrees,
with 0 (360) facing east  and values increasing in the counter clockwise direction at 45 degree increments.
The \fIgrass\fR format gives the same category values as the \fIr.slope.aspect\fR program.

.SH NOTE
.I The r.direct
program is sensitive to the \fBcurrent window setting\fR. Thus the
program can be used to generate a flow direction map for any sub-area within the
full map layer. Also, \fIr.direct\fR is sensitive to
any \fImask\fR in effect.

.SH SEE ALSO
r.fill.dir, r.slope.aspect

.SH "AUTHOR"
Raghavan Srinivasan, Agricultural Engineering Department, Purdue University
