.TH i.in.erdas
.SH NAME
\fIi.in.erdas\fR \-Creates raster files from ERDAS files.
.br
.I "(GRASS Raster Program)"
.SH SYNOPSIS
\fBi.in.erdas\fR
.br
\fBi.in.erdas help\fR
.br
\fBi.in.erdas\fR [\fB\-l\fR] \fBinput=\fIname\fR \fBoutput=\fIname\fR
\fB[trailer=\fIname]\fR \fB[bands=\fIvalue[,value,...]]\fR
\fB[srow=\fIvalue]\fR \fB[scol=\fIvalue]\fR \fB[rows=\fIvalue]\fR
\fB[cols=\fIvalue]\fR
.SH DESCRIPTION
This program creates raster map files from ERDAS files.  It 
creates one raster file for each selected band, up to a maximum of seven bands.
GRASS color and category support files are created if an ERDAS trailer
file is specified.
.br
Only ERDAS version 7.4 or later files in 4-bit, 8-bit, or 16-bit formats
are supported.
.br
GRASS raster files will be named \fIprefix.band\fR

Note:
.RS
Remember that it is necessary to run:
\fIr.support\fR: to create the histogram or change the color table.
\fIi.group\fR: to associate the individual raster files as an image group.
.RE
.SH "COMMAND LINE OPTIONS"
.LP
Flags:
.IP \fI-l\fR
List the ERDAS header only (no raster files created)
.LP
Parameters:
.IP \fIinput\fR
ERDAS input file name
.IP \fIoutput\fR
output prefix of the GRASS raster files to be created.
.IP \fItrailer\fR
ERDAS trailer input file name
.IP \fIbands\fR
Selected bands to extract. (defaults to all bands)
.IP \fIsrow\fR
Starting row. (defaults to first row in file)
.IP \fIscol\fR
Starting column. (defaults to first column in file)
.IP \fIrows\fR
Number of rows to extract. (defaults to all rows)
.IP \fIcols\fR
Number of columns to extract. (defaults to all columns)

.SH "SEE ALSO"
r.support, i.group

.SH AUTHOR
M.L. Holko, USDA, SCS, NHQ-CGIS
.br
Paul H. Fukuhara, USDA, SCS, NCG-GSS
