.TH v.in.shape 1
.SH NAME
\fIv.in.shape\fR \- Read an ArcView Shapefile
.br
.SH SYNOPSIS
\fBv.in.shape\fR
.br
.nf
\fBv.in.shape \fR \fBinput=\fIname \fR[\fBmapset=\fIname\fR] \fR[\fBverbose=\fIdebug level\fR] \fR[\fBlogfile=\fIname\fR] \fR[\fBattribute=\fIa_name\fR]
.br 
.fi
.SH DESCRIPTION
.LP
The \fIv.in.shape\fR program is designed to import ArcView Shapefiles.
.LP
.br
\fIv.in.shape\fR will be run non-interactively if the user specifies program arguments on the command line, using the form:
.br
.nf
\fBv.in.shape \fR \fBinput=\fIname \fR[\fBmapset=\fIname\fR] \fR[\fBaction=\fIwhat to do\fR] \fR[\fBverbose=\fIdebug level\fR] \fR[\fBlogfile=\fIname\fR]
.br
.fi
.LP
Alternately, the user can simply type:
.LP
.RS
\fBv.in.shape\fR
.RE
.LP
on the command line without program arguments.
In this case, the user will be prompted for parameter values using the standard
GRASS user interface described in the manual entry for \fIparser\fR.
.SH FEATURES
.LP
Grass files created have the name extracted from the basename of the shapefile.
.SH OPTIONS
.LP
.IP \fBmapset=\fIname\fR 18
For creating a new mapset for the data imported.
This may be usefull, since we cannot
create a projection info file and a default window in an existing mapset.
When a file is imported in the current mapset, you should take care that 
they are in the same projection.
.sp 0.3
Unfortunately, you may run in trouble after that when using g.region (Cf BUGS).
.IP "\fBverbose=\fIdebug level\fR" 18
Number between 0 (no trace of what's happening) and 9 (very verbose log).
.IP \fBlogfile=\fIname\fR 18
Name of file where log info will be written. By default log info are directed to \fIstderr\fR.
.IP \fBattribute=\fIa_name\fR 18
Name of the attribute to use as the category number in dig_att.  Give a value 
of \fBlist\fR to see a list of available attributes. 
.SH BUGS AND CAVEAT
.LP
Polygons with internal holes are not treated properly.  The holes are
just treated as a continuation of the polygon. 
.LP
There is no support for projection.
.LP
Label for polygons are located on the edge, rather than interior to the 
polygon.  This is ambiguous in cases of polygons that share boundaries
with other polygons and will cause conflicts when running
.I v.support.
.LP
New mapset are allways created with proj=0 zone=99.  If the default proj and
zone are not the same, g.region complaints and d.vect or d.rast refuse to
display your data.  The only thing to do is to import in the current mapset.
.SH SEE ALSO
.br
.I m.in.e00
.I g.mapset ,
.I g.region ,
.I g.proj ,
.I v.support ,
.I v.to.rast .
.SH AUTHORS
Frank Warmerdam (warmerda@home.com)
.br
Based on Shapelib (http://gdal.velocet.ca/projects/shapelib/). 
.LP
