.TH v.plant
.SH NAME
.\" comment
\fIv.plant\fR \- inserts extra points along lines in a vector map.
.br
.I (GRASS Vector Program)
.SH SYNOPSIS
\fBv.plant\fR
.SH DESCRIPTION
\fIv.plant\fR allows a user to insert extra points within arcs in a vector map.  
.LP
The user is prompted for the vector map to be processed, 
and the minimum spacing of points along the arcs.  
\fIv.plant\fR then processes the map by working along each 
arc in turn, and if the spacing between two successive points is 
greater than this threshold value, extra points are inserted.  
The inserted points lie along straight-line segments between the 
existing points, which are all retained, so the shape of the arcs 
are not changed in any way.  
This has approximately the reverse effect to \fIv.prune\fR.  
.SH OPTIONS
.LP
\fIv.plant\fR is an interactive program.  
.SH NOTES
This procedure is useful for processing vector maps which contain 
simple straight-lines prior to moving them to a new location using \fIv.proj\fR.  
With insufficient points to define them, straight-lines in the original projection 
will remain as straight-lines in the new projection, 
instead of correctly being converted into curves.   
.LP
This is implemented as a Bourne shell script, 
which calls \fIv.out.ascii\fR (GRASS main), 
to write out an ascii version of the map.  
This is then processed using an \fIawk\fR program, 
and the resulting map is re-imported using \fIv.in.ascii\fR.  
.LP
The original map is overwritten.  
All the original topology and attributes are preserved.  
.LP
.SH SEE ALSO
.I v.prune,
.I v.proj,
.I g.setproj
.SH BUGS
A command-line version would be nice.  
.LP
Please send all bug fixes and comments to the author.
.SH AUTHOR
Simon Cox, AGCRC, CSIRO Exploration & Mining
.if n .br 
(simon@ned.dem.csiro.au)
