.TH v.what
.SH NAME
\fIv.what \fR\- Query the category contents of a (binary) vector map layer 
at user-selected locations.
.br
.I "(GRASS Vector Program)"
.SH SYNOPSIS
\fBv.what\fR
.br
\fBv.what help\fR
.br
\fBv.what \fR[\fB-1i\fR] \fBmap\*=\fIname\fR
.SH DESCRIPTION
.I v.what
outputs the category value(s) associated with user-specified location(s)
in a vector map layer.  

."This map layer must exist in the user's current mapset search path.
." This program currently returns
." only category values for line types in the user-specified vector file.
." The program will query the contents of the vector map layer named by the
." user on the command line.  
If the \fB-i\fR flag is specified, the program activates the mouse, and 
expects the user to indicate the location(s) to be queried by depressing 
a mouse button over desired location(s) within the current geographic region 
in the active display frame on the graphic monitor.  

If the \fB-i\fR flag is not used, the program expects eastings and northings
to be entered from standard input.  In this case, input is terminated by
typing Control-D.
.LP
\fBFlags:\fR
.IP \fB-1\fR 18
Identify and query just one point location.  
.IP \fB-i\fR 18
Query interactively using mouse. 
." User must depress the mouse while the pointer is
." located at the desired location in the graphics monitor.
.LP
\fBParameter:\fR
.IP \fBmap\*=\fIname\fR 18
Name of an existing binary vector map in the user's mapset search path.
.SH EXAMPLE
Two sample \fIv.what\fR sessions are given below.  

Although it is not necessary that the user first display a vector map to be 
queried in the active display frame, it is helpful to have a map displayed 
there for reference for interactive queries.

.IP "\fBd.vect map\*=roads.24000\fR" 18
.".br
." Displays the 1:24,000 scale \fIroads\fR vector map layer on the graphics monitor.
."
.IP "\fBv.what -i map\*=roads.24000\fR" 18
.br
After typing this, the user moves the mouse to a desired location
on the displayed \fIroads\fR map layer,
and presses the left mouse button to query the category value of the
\fIroads\fR vector map at this location.  The program then
outputs the category value of a line type corresponding to this
user-selected map location, for the vector map queried by the user.

The query may be repeated as often as desired using the left mouse button.
The right button on the mouse is used to quit the \fIv.what\fR session.
.LP
Users can also use this program inside of shell scripts. For example,
if the file \fIcoords\fR contains three UTM coordinates:
." .IP " " 18
." c s
.TE
\fR
.if t \fB
.TS
box, center, tab(:);
l l.
599817.37:4922332.96
593512.25:4917170.38
604979.96:4921655.90
.TE
\fR
.fi

.IP "\fBcat coords | v.what map\*=landcover\fR" 18
.br
will return information about these three locations and then exit.
.SH NOTES
." Currently, \fIv.what\fR only outputs category values for lines.
." It does not output category labels for lines, nor output
." category values or category labels for areas in a vector file.
.LP
." .I v.what
." will always print its output to the user's terminal screen.
\fIv.what\fR output can be redirected into a file.
.LP
\fId.what.rast\fR can be used to interactively query the map category contents
of multiple raster map layers at user-selected locations.
.LP
\fIv.what\fR was created from \fId.what.rast\fR so that non-interactively
queries could be made. Specifying the \fB-i\fR flag makes \fIv.what\fR 
behave just as \fId.what.rast\fR did.
.SH SEE ALSO
." .I d.rast,
.I d.vect,
.I d.what.rast,
.I d.what.vect,
.I g.region,
and
.I parser
.SH "AUTHORS"
Jim Hinthorn, Central Washington University
." original author
." jimh@strider.tfo.arizona.edu (as of 14 Aug 1992)
.br
Dennis Finch, National Park Service
." made some changes??
." (email address unknown)
.br 
Darrell McCauley, Purdue University 
." mccauley@ecn.purdue.edu
." added non-interactive part and renamed to v.what <14 Aug 1992>

