.TH m.in.e00 1
.SH NAME
\fIm.in.e00\fR \- Read an ESRI e00 file
.br
.SH SYNOPSIS
\fBm.in.e00\fR
.br
.nf
\fBm.in.e00 \fR \fBinput=\fIname \fR[\fBmapset=\fIname\fR] \fR[\fBaction=\fIwhat to do\fR] \fR[\fBverbose=\fIdebug level\fR] \fR[\fBlogfile=\fIname\fR]
.br 
.fi
.SH DESCRIPTION
.LP
The \fIm.in.e00\fR program is designed to import ESRI Arc/Info e00 ascii archives.
The \fBinput\fR file must be in ascii (no binary compressed) e00 file.
.LP
The program not only can analyse the content of an Arc/Info file, but try to create
the objects described (geometry and attributes).
.br
\fIm.in.e00\fR will be run non-interactively if the user specifies program arguments on the command line, using the form:
.br
.nf
\fBm.in.e00 \fR \fBinput=\fIname \fR[\fBmapset=\fIname\fR] \fR[\fBaction=\fIwhat to do\fR] \fR[\fBverbose=\fIdebug level\fR] \fR[\fBlogfile=\fIname\fR]
.br
.fi
.LP
Alternately, the user can simply type:
.LP
.RS
\fBm.in.e00\fR
.RE
.LP
on the command line without program arguments.
In this case, the user will be prompted for parameter values using the standard
GRASS user interface described in the manual entry for \fIparser\fR.
.SH FEATURES
.LP
\fBm.in.e00\fR attemps to retrieve all information in an Arc/Info export
file (.e00)\ : points, line, polygon and grid coverage.
The attribut of each "vector" object (points, line, and polygon) is the
Arc/Info coverage-ID (and not the coverage-#).
.LP
Grass files created have the name extracted from the first line of the e00
file, i.e. the name of the coverage.
.LP
The following rules are used :
A line vector file is created when there is a non-empty ARC section, and
neither PAL (Polygon Attribute Label) section, neither PAT (Point/Polygon
Attribute Table) table in IFO section.
Otherwise a polygon vector file is created, excepted when the ARC section
is empty or doesn't exist, in which case a site file is created.
.LP
Dig_cats files are created if the PAT or AAT (Arc Attribute Table) tables
have more attributes than the standars one.
If there is one extra attribute, the dig_cats file
has the name of the vector (dig) file created.
If there is more than one extra attribute, the dig_cats files have names of
the form cover_name.attribute_name.
If you want to use one of them, you must rename it so it match the name of the
vector file.  Doing this, v.to.rast will use it for the raster file created.
.SH OPTIONS
.LP
.IP \fBmapset=\fIname\fR 18
For creating a new mapset for the data imported.
This may be usefull, since we cannot
create a projection info file and a default window in an existing mapset.
When a file is imported in the current mapset, you should take care that they are in
the same projection.
.sp 0.3
Unfortunately, you may run in trouble after that when using g.region (Cf BUGS).
.IP "\fBaction=\fIwhat to do\fR" 18
Five options: \fIanalyse\fR, \fIraster\fR, \fIlines\fR, \fIvector\fR and \fIall\fR.
.sp 0.3
By default, all is used and everything (grid, points, lines, polygons) is
imported.
\fIAnalyse\fR produce no files, but only a log output (level 5) on stderr,
and is usefull to see whether the e00 file is clean or not.
\fIRaster\fR imports only grid section.
\fILines\fR imports only the geometry (no label are attached to the lines
or polygons) of a point/line/polygon coverage.
\fIVector\fR imports a point/line/polygon coverage with their attributes.
.IP "\fBverbose=\fIdebug level\fR" 18
Number between 0 (no trace of what's happening) and 9 (very verbose log).
.IP \fBlogfile=\fIname\fR 18
Name of file where log info will be written. By default log info are directed to \fIstderr\fR.
.SH BUGS AND CAVEAT
.LP
Binary files are rejected.  You must use e00b2a before to convert binary
e00 files to ascii.
.LP
You must know what to do with all the dig_cats file generated when importing
a vector coverage.
.LP
No attribute (cats) file is produced when importing a grid.
.LP
The program may crash when unexpexted data (mainly in IFO section) are found,
or when the input file is corrupted.
.LP
There is no support for projection. using verbose=1 let you see the
parameters of the e00 file, but you must create the DEFAULT_WIND and
the PROJ file yourself.
.LP
New mapset are allways created with proj=0 zone=99.  If the default proj and
zone are not the same, g.region complaints and d.vect or d.rast refuse to
display your data.
The only thing to do is to import in the current mapset.
.SH SEE ALSO
.br
.I e00b2a "(convert binary e00 file to ascii e00 file),"
.I g.mapset ,
.I g.region ,
.I g.proj ,
.I v.support ,
.I v.to.rast .
.SH AUTHORS
Michel J. Wurtz, Laboratoire Territoires & Environnement,
.sp -0.3
.IP
Ecole Nationale du Genie de l'Eau et de l'Environnement.
.br
mw@engees.u-strasbg.fr
.LP
