


r.contour            GRASS Reference Manual             r.contour



NAME
     r.contour - Produces a GRASS binary vector map of specified
     contours from GRASS raster map layer.

SYNOPSIS
     r.contour
     r.contour help
     r.contour input=name output=name
     [levels=value,value,...,value] [minlevel=value]
                 [maxlevel=value] [step=value]

DESCRIPTION
     r.contour produces a contour map of user-specified levels
     from a raster map layer. This program works two ways:

          1. Contours are produced from a user-specified list of
          levels.

          2. Contours are produced at some regular increment from
          user-specified minimum level to maximum level. If no
          minimum or maximum level is specified, minimum or
          maximum data value will be used.

     Parameters:

     input=name        Name of input raster map layer.

     output=name       Name of the binary vector file created.

     levels=value,value,...,value
                       Comma seperated list of desired levels.

     minlevel=value    Beginning (lowest) value to be used when
                       stepping through contours. Default is
                       minimum data value.

     maxlevel=value    Ending (highest) value to be used when
                       stepping through contours. Default is
                       maximum data value.

     step=value        Increment between contour levels.

     r.contour may be run interactively or non-interactively. To
     run the program non-interactively, the user must specify the
     input and output file names, either a list of levels or a
     step value and, optionally, minimum and maximum levels:

          r.contour input=name output=name
          [levels=value,value,...,value] [minlevel=value]
                      [maxlevel=value] [step=value]





GRASS 4.1                U.S. Army CERL                         1






r.contour            GRASS Reference Manual             r.contour



     To run the program interactively, the user may simply type
     r.contour at the command line and will be prompted for
     parameter values.

NOTES
     r.contour will either step through incremental contours or
     produce contours from a list of levels, not both. If both a
     list of levels and a step are specified, the list will be
     produced and the step will be ignored.

     Currently, 0 is treated as a valid data value by r.contour.

     If a contour level exactly matches a category value in the
     raster file, the contour line may backtrack on itself,
     causing illegal arcs to be produced in the output GRASS
     vector file.

AUTHOR
     Terry Baker, U.S. Army Construction Engineering Research
     Laboratory



































GRASS 4.1                U.S. Army CERL                         2



