.TH r.in.hdf
.SH NAME
\fIr.in.hdf\fR \- Convert data in HDF format into a (binary) raster map layer. 
.br
.I "(GRASS Raster Data Import Program)"
.SH SYNOPSIS
\fBr.in.hdf\fR
.br
\fBr.in.hdf help\fR
.br
\fBr.in.hdf\fR [\fB\-q\fR] [\fB\-a\fR] [\fB\-l\fR] \fBinput=\fIname\fR [\fBoutput=\fIname\fR] [\fBmult=\fIvalue\fR] [\fBdsets=\fIvalue\fR[\fI,value,...\fR]]
.SH DESCRIPTION
\fIr.in.hdf\fR allows a user to create a GRASS raster map layer from a file 
in NCSA Hierarchical Data Format (HDF).
.SH "COMMAND LINE OPTIONS"
.LP
Flags
.IP \fI-q\fR
Run quietly
.IP \fI-a\fR
Convert ALL data sets in the HDF file
.IP \fI-l\fR
Only list the contents of the HDF file (no conversion)
.LP
Parameters
.IP \fIinput\fR
HDF file to be converted.
.IP \fIoutput\fR
Name of new raster file. (default: hdf.rast)
.IP \fImult\fR
Floating point multiplier. (rastfile = (int)(file.hdf * multiplier))
.IP \fIdsets\fR
A list of reference numbers for datasets to be extracted.
.LP
The raster file created will have its southwest origin at 0 East and 0 North,
with resolution of 1.  To view the new GRASS raster file, use
\fIg.region rast=newfile\fR, then use \fId.rast\fR as normal.  You may
wish to manually change the new raster's cellhd file.
.LP
NCSA HDF is a multi-object file format developed by The National Center for
Supercomputing Applications at Champaign, Illinois
for the transfer of graphical and 
floating-point data between machines.  NASA Pathfinder AVHRR data is 
stored in HDF format.  The HDF format defines both a raster 
type and a SDS (scientific data set) type.
The later is basically a highly structured 
multi-dimensional array of values.  A single HDF file
may contain more than one SDS or raster; using the \fI-a\fR option 
will extract all data sets from the HDF file, creating a 
seperate GRASS raster file from each data set and naming 
the raster files \fIoutputname01, outputname02, outputname03...\fR.  
If the \fI-a\fR option is not specified and the HDF file contains more
than one data set, only the first data set is extracted unless the user
specifies specific reference numbers for desired data sets in the file using 
the \fIdsets\fR option.  To see a list of reference numbers for data sets
in an HDF file, use the \fI-l\fR flag.  If the HDF file contains labels or
descriptions of the data, these will be shown when using the \fI-l\fR
flag.  Labels and descriptions from the HDF file will also be written
to the GRASS history file when creating the raster map.
If a multiplier is given using the 
\fImult\fR option, every file created will be the product of the input
data set and the multiplier.
If the HDF file contains an SDS, it must
be only two dimensional in order for \fIr.in.hdf\fR to accept it as input.
If the HDF file contains an 8-bit raster image with an associated palette,
a GRASS color file will be created.  This program will not import 24-bit
HDF raster images.
.LP
NCSA distributes the HDF library and several public domain visualization
applications which use the HDF format.  Some commercial applications
also support HDF.  For more information, use the NCSA anonymous ftp server
\fIftp.ncsa.uiuc.edu\fR or contact:
.IP
NCSA
.br
152 Computing Applications Building
.br
605 E. Springfield Ave.
.br
Champaign, IL 61820
.br
(217) 244-0072
.SH BUGS
If a data set contains long labels and descriptions, some of it may
be truncated when writing to the GRASS history file.  The GRASS history
structure currently allows 50 lines of 80 characters each.  But when
editing history using r.support, only 20 lines of 65 characters may be used.

.SH "SEE ALSO"
r.out.hdf, r.support, g.region

.SH AUTHOR
Bill Brown, U.S. Army Construction Engineering Research Laboratory

