.TH r.out.hdf
.SH NAME
\fIr.out.hdf\fR \- Convert data in a GRASS raster map layer into HDF format. 
.br
.I "(GRASS Raster Data Export Program)"
.SH SYNOPSIS
\fBr.out.hdf\fR
.br
\fBr.out.hdf help\fR
.br
\fBr.out.hdf\fR [\fB\-q\fR] \fBinput=\fIname\fR \fB[output=\fIname\fB] \fB[mult=\fIvalue\fB]
.SH DESCRIPTION
\fIr.out.hdf\fR allows a user to create a data file in NCSA Hierarchical Data Format (HDF) from an existing GRASS raster file.  
.SH "COMMAND LINE OPTIONS"
.LP
Flags
.IP \fI-q\fR
Run quietly
.LP
Parameters
.IP \fIinput\fR
Raster file to be converted.
.IP \fIoutput\fR
Name for new hdf file.
.br
default: <rasterfilename>.hdf
.IP \fImult\fR
Floating point multiplier. (file.hdf = cellfile * multiplier)
.LP
NCSA HDF is a multi-object file format developed by The National Center for
Supercomputing Applications at Champaign, Illinois
for the transfer of graphical and
floating-point data between machines.  The format defines both a raster
type and a SDS type.  The later is basically a highly structured
multi-dimensional array of floating point values.  A single HDF file
may contain more than one SDS, but using \fIr.out.hdf\fR will create a 
single HDF file containing a single 2-dimensional SDS.  The HDF raster format
consists of a palette and a 2D array of 8-bit numbers,
but \fIr.out.hdf\fR does not
yet create this format file, so color tables are not transferrable.
.LP
NCSA distributes the HDF library and several public domain visualization
applications which use the HDF format.  Some commercial applications
also support HDF.  For more information, use the NCSA anonymous ftp server
\fIftp.ncsa.uiuc.edu\fR or contact:
.IP
NCSA
.br
152 Computing Applications Building
.br
605 E. Springfield Ave.
.br
Champaign, IL 61820
.br
(217) 244-0072

.SH "SEE ALSO"
r.in.hdf

.SH AUTHOR
Bill Brown, U.S. Army Construction Engineering Research Laboratory

