/*************************************************************************/
/**	                                                       		**/
/**                           	r.lags            			**/
/**  GRASS module for 2D lag graphs from spatial dependence measures.	**/
/**  									**/
/**                                                    			**/
/**		  Jo Wood, V 2.1, 18th September, 1995			**/
/**                                      				**/
/*************************************************************************/

#define MAIN

#include "lags.h"	

main(argc,argv) 
    int argc;
    char *argv[];
{

    /*------------------------------------------------------------------*/
    /*                           INITIALISE				*/
    /*------------------------------------------------------------------*/ 

    /*------------------------------------------------------------------*/
    /*                        GET INPUT FROM USER			*/
    /*------------------------------------------------------------------*/

    interface(argc,argv);


    /*------------------------------------------------------------------*/
    /*                 OPEN INPUT AND OUTPUT RASTER FILES		*/
    /*------------------------------------------------------------------*/

    open_files();


    /*------------------------------------------------------------------*/
    /*               PROCESS SURFACE FOR FEATURE DETECTION 		*/
    /*------------------------------------------------------------------*/

    if (measure==MORAN)
        autocorr(); 
    else
	if (measure==TEXTURAL)
            comatrix();

    /*------------------------------------------------------------------*/
    /*               CLOSE ALL OPENED FILES AND FREE MEMORY		*/
    /*------------------------------------------------------------------*/

    close_down();

    write_cols();

}
