.TH r.statistics
.SH NAME
\fIr.statistics\fR \- Category- or objectoriented statistics
.br
.I "(GRASS Raster Program)"
.SH SYNOPSIS
\fBr.statistics\fR
.br
\fBr.statistics help\fR
.br
\fBr.statistics\fR [\fB\-c\fR] \fBbase=\fIname\fR
\fBcover=\fIname\fR \fBmethod=\fIname\fR [\fBoutput=\fIname\fR]

.SH BESCHREIBUNG
\fBr.statistics\fR is a tool, where different class-,
resp. objectoriented statistical analysis methods are possible.
The methods are the following:

      [english]  \fR
- [german]
.IP   \fBdistribution\fR 
-  Verteilung in Prozent
.IP   \fBaverage\fR 
-  Durchschnitt
.IP   \fBmode\fR 
-  Modalwert
.IP   \fBmedian\fR        
-  Median
.IP   \fBavedev\fR        
-  Durchschnittliche Abweichung
.IP   \fBstddev\fR       
-  Standardabweichung
.IP   \fBvariance\fR      
-  Varianz
.IP   \fBskewness\fR      
-  Schiefe der Verteilung
.IP   \fBkurtosis\fR      
-  Relative Abflachung (-) oder Zuspitzung (+)
.IP   \fBmin\fR           
-  Minimum
.IP   \fBmax\fR           
-  Maximum
.IP   \fBsum\fR           
-  Summe


.SH "COMMAND LINE OPTIONS"
.LP
Flags
.IP \fI-c\fR
Values are taken from category lables of the \fIcovering\fR-layer, instead of 
\fIcovering\fR-layer itself.
.LP
Parameter
.IP \fIbase\fR
base raster map
.IP \fIcover\fR
cover raster map
.IP \fImethod\fR
Statistical method
.br
options: distribution, average, mode, median, avedev, stddev,
variance,
skewness, kurtosis, min, max, sum
.IP \fIoutput\fR
Name of the new layer (not when using 'distribution')

The calculations will be performed for areas with data of the \fIcovering\fR-layers 
which belong in the \fIbase\fR-layer o the same category.

Setting the \fI-c\fR flag  the category lables of the
\fIcovering\fR raster layer will be used.
This is nice to avoid the GRASS limitation to interger in raster maps
because using category values floating point numbers can be stored.


The \fIoutput\fR-layer is a reclassified version of the
\fIbase\fR-layer with identical category values. The
results of the calculations are stored in the category labels
of the \fIoutput\fR-layer.

The described output is valid for all calculations with
exception of \fIdistribution\fR. Here
the output is given to stdout. A file name eventually specified
will be ignored. The result will be a table with three columns.
In the 1. column are the category values of the base-layer (a), in
the 2. column the associated value of the cover-Layers (b) and in der 3.
column the percentage of b from a. Example:

                   1   124  23
                   1   201  47
                   1   273  30
                   2   101  5
                   2   152  16
                   2   167  60
                   2   187  19
                        .
                        .
                        .


.SH REMARK
The source code of average, mode and median was taken
from some GRASS raster modules.


.SH BUGS
unkown.

.SH "SEE ALSO"
r.mode, r.median, r.average, r.neighbors

.SH AUTHOR
Martin Schroeder,  Geographisches Institut Heidelberg, Germany
                   Internet: emes@geo1.geog.uni-heidelberg.de
This text is a quick and dirty translation of Markus Neteler.

