.TH s.sample
.SH NAME
.\" comment
\fIs.sample\fR \- Sample a raster file at site locations.
.br
.I (GRASS Sites Program)
.SH SYNOPSIS
\fBs.sample\fR
.br
\fBs.sample help\fR
.br
\fBs.sample \fR[\fB-BCcdlq\fR] \fBinput\*=name\fR [\fBoutput\*=\fIname\fR]
\fBrast\*=name\fR [\fBz\*=\fIname\fR]
.SH DESCRIPTION
.I s.sample
samples a GRASS raster map at the site locations in the input
file by either cubic convolution interpolation, bilinear 
interpolation, or nearest neighbor sampling (default).
Categories values are sampled.
.LP
This program may be especially useful when sampling for cross
validation of interpolations whose output is a raster map.
.SH OPTIONS
\fBFlags:\fR
.IP \fB-B\fR 18
Use bilinear interpolation.
.IP \fB-C\fR 18
Use cubic convolution interpolation.
.IP \fB-c\fR 18
Use numeric category labels instead of category values.
.IP \fB-d\fR 18
Calculate difference between raster value and site value
(raster minus site).
.IP \fB-l\fR 18
If site is in the \fIE|N|#n label\fR format (instead of the
\fIE|N|label\fR format), use
the numeric \fIlabel\fR as the site value. Implies the \fB-d\fR flag.
.IP \fB-q\fR 18
Quiet. Cut out the chatter.
.LP
\fBParameters:\fR
.IP \fBinput\*=\fIname\fR 18
Name of sites list defining sample points.
.LP
.IP \fBoutput\*=\fIname\fR 18
Optional name of sites list in which output will be stored. 
Standard output is used if this is missing.
.LP
.IP \fBrast\*=\fIname\fR 18
Name of raster map to be sampled.
.LP
.IP \fBz\*=\fIvalue\fR 18
Option scaling factor for values read from raster map. Sampled values
will be multiplied by this factor. If omitted, this is set
to 1.0.
.SH NOTES
If any of \fB-cdl\fR are specified, it is important that
the raster category label and/or the site description
are numeric. No error checking is done except for "no data"
values as raster category labels. In this instance, a 
warning is issued and a zero value is assumed.
.LP
This program may not work properly with lat-long data
when the \fB-BC\fR flags are used.
.LP
When interpolation is done (i.e., the \fB-BC\fR flags are used),
values are assumed to be located at the centroid of grid cells.
Therefore, current resolution settings are important. 
.LP
.SH SEE ALSO
.I s.rand,
.I s.kcv,
.I g.region
and
\fIImage Sampling Methods\fR \- 
GRASS Tutorial on \fIs.sample\fR
(available as s.sample-tutorial.ps)
.SH BUGS
Please send all bug fixes and comments to the author.
.SH AUTHOR
James Darrell McCauley, Agricultural Engineering, Purdue University 
.if n .br 
(mccauley@ecn.purdue.edu)
