/*********************************************************************
 *   Copyright 1989, University Corporation for Atmospheric Research
 *   See netcdf/README file for copying and redistribution conditions.
 *   $Header: /u2/ldm/src/netcdf/ncgen/RCS/close_netcdf.c,v 1.1 89/05/04 09:30:59 russ Exp $
 *********************************************************************/

#include <stdio.h>
#include "ncgen.h"

extern Void derror();
extern int netcdf_flag;
extern int c_flag;
extern int fortran_flag;

static Void
cl_netcdf()
{
    if (ncclose(cdfid) == -1)
      derror ("error closing netcdf");
}

extern FILE *cout;			/* for generated C code */
extern FILE *fout;			/* for fortran output */

#define fpr    (Void) fprintf

static Void
cl_c()
{
    fpr(cout, "   ncclose (cdfid);\n");
    fpr(cout, "}\n");
}


static Void
cl_fortran()
{
    fpr(fout, "\n      call ncclos (cdfid)\n");
    fpr(fout, "\n      end\n");
}



Void
close_netcdf()
{
    if (netcdf_flag)
      cl_netcdf();		/* close netcdf */
    if (c_flag)			/* create C code to close netcdf */
      cl_c();
    if (fortran_flag)		/* create Fortran code to close netcdf */
      cl_fortran();
}

