/*********************************************************************
 *   Copyright 1989, University Corporation for Atmospheric Research
 *   See netcdf/README file for copying and redistribution conditions.
 *   $Header: /u2/ldm/src/netcdf/ncgen/RCS/main.c,v 1.2 89/10/30 14:33:44 russ Exp $
 *********************************************************************/

#include <stdio.h>
#include <string.h>
#include "ncvoid.h"

extern Void derror();
extern Void *emalloc();

char *progname;

int c_flag;
int fortran_flag;
int netcdf_flag;
char *netcdf_name = NULL;	/* name of output netCDF file to write */

extern FILE *yyin;

main(argc, argv)
int argc;
char *argv[];
{
    extern int optind;
    extern int opterr;
    extern char *optarg;
    int c;
    FILE *fp, *efopen();

    opterr = 1;			/* print error message if bad option */
    progname = argv[0];

    c_flag = 0;
    fortran_flag = 0;
    netcdf_flag = 0;

    while ((c = getopt(argc, argv, "cfno:")) != EOF)
      switch(c) {
	case 'c':
	  c_flag = 1;
	  break;
	case 'f':
	  fortran_flag = 1;
	  break;
	case 'n':
	  netcdf_flag = 1;
	  break;
	case 'o':
	  netcdf_flag = 1;
	  netcdf_name = (char *) emalloc(strlen(optarg)+1);
	  (void)strcpy(netcdf_name,optarg);
	  break;
	case '?':
	  usage();
	  break;
      }

    argc -= optind;
    argv += optind;

    if (argc > 1) {
	derror ("%s: only one input file argument permitted",progname);
	exit(1);
    }

    fp = stdin;
    if (argc > 0 && strcmp(argv[0], "-") != 0)
	if ((fp = fopen(argv[0], "r")) == NULL) {
	    derror ("can't open file %s for reading: ", argv[0]);
	    perror("");
	    exit(1);
	}
    yyin = fp;
    exit(yyparse());
}

usage()
{
    derror("Usage: %s [ -c ] [ -f ] [ -n ] [ -o outfile]  [ file ... ]", progname);
    exit(1);
}
