/*********************************************************************
 *   Copyright 1989, University Corporation for Atmospheric Research
 *   See netcdf/README file for copying and redistribution conditions.
 *   $Header: /u2/ldm/src/netcdf/ncgen/RCS/ncgen.h,v 1.1 89/05/04 09:31:04 russ Exp $
 *********************************************************************/

#include "netcdf.h"
#include "ncvoid.h"		/* defines Void */
#include "generic.h"		/* defines union generic */

#define MAX_NC_ATTSIZE    2000	/* max size in bytes of an attribute */
#define MAX_NC_ATTS        500	/* max number of attributes in a netCDF */
#define MAXTRST		   500	/* maximum size of a single string value */

struct {			/* dimensions */
    int size;
    char name[MAX_NC_NAME];
} dims[MAX_NC_DIMS];		/* table of netcdf dimensions */

int cdfid;			/* handle for netCDF */
int ndims;			/* number of dimensions declared for netcdf */
int nvars;			/* number of variables declared for netcdf */
int natts;			/* number of attributes */
int nvdims;			/* number of dimensions for variables */
int dimnum;			/* dimension number index for variables */
int varnum;			/* variable number index for attributes */
int valnum;			/* value number index for attributes */
int rec_dim;			/* number of the unlimited dimension, if any */
int var_len;			/* variable length (product of dimensions) */
int var_size;			/* size of each element of variable */
int netcdf_record_number;	/* current record number for variables */

struct {			/* variables */
    char name[MAX_NC_NAME];
    nc_type type;
    int ndims;
    int dims[MAX_VAR_DIMS];
    union generic fill_value;	/* set to value of fill_value attribute */
    int has_data;		/* 1 if data specified, 0 otherwise */
} vars[MAX_NC_VARS];

struct {
    int var;			/* number of variable for this attribute */
    char name[MAX_NC_NAME];
    nc_type type;
    int len;
    Void *val;
} atts[MAX_NC_ATTS];		/* should be a malloc'ed list, not an array */
