/*********************************************************************
 *   Copyright 1989, University Corporation for Atmospheric Research
 *   See netcdf/README file for copying and redistribution conditions.
 *   $Header: /u2/ldm/src/netcdf/nctest/RCS/driver.c,v 1.2 89/10/19 14:27:50 russ Exp $
 *********************************************************************/

#include "netcdf.h"
/* #define MDEBUG 1 */

  /*
   * Test driver for netCDF implementation.  This program performs
   * tests against the netCDF specification for all user-level
   * functions in an implementation of the netCDF library.  Must be
   * invoked from a directory in which the invoker has write
   * permission.
   */

main()
{
    extern void test_nccreate(), test_ncopen(), test_ncredef(),
    test_ncendef(), test_ncclose(), test_ncinquire(),
    test_ncsync(), test_ncabort(), test_ncdimdef(),
    test_ncdimid(), test_ncdiminq(), test_ncdimrename(),
    test_ncvardef(), test_ncvarid(), test_ncvarinq(),
    test_ncvarput1(), test_ncvarget1(), test_ncvarput(),
    test_ncvarget(), test_ncvarrename(), test_ncattput(),
    test_ncattinq(), test_ncattget(), test_ncattcopy(),
    test_ncattname(), test_ncattrename(), test_ncattdel(),
    test_nctypelen();
    extern void error();	/* prints error messages, uses varargs */
    extern int ncopts;		/* error options */

    static char testfile[] = "test.cdf";

#ifdef MDEBUG
    malloc_debug(2);
#endif /* MDEBUG */

    ncopts &= ~NC_FATAL;	/* make errors nonfatal */
    ncopts &= ~NC_VERBOSE;	/* turn off error messages */

    test_nccreate(testfile);

    test_ncopen(testfile);

    test_ncredef(testfile);

    test_ncendef(testfile);

    test_ncclose(testfile);

    test_ncinquire(testfile);

    test_ncsync(testfile);

    test_ncabort(testfile);

    test_ncdimdef(testfile);

    test_ncdimid(testfile);

    test_ncdiminq(testfile);

    test_ncdimrename(testfile);

    test_ncvardef(testfile);

    test_ncvarid(testfile);

    test_ncvarinq(testfile);

    test_ncvarput1(testfile);

    test_ncvarget1(testfile);

    test_ncvarput(testfile);

    test_ncvarget(testfile);

    test_ncvarrename(testfile);

    test_ncattput(testfile);

    test_ncattinq(testfile);

    test_ncattget(testfile);

    test_ncattcopy(testfile, "test2.cdf");

    test_ncattname(testfile);

    test_ncattrename(testfile);

    test_ncattdel(testfile);

    test_nctypelen();
}
