/*********************************************************************
 *   Copyright 1989, University Corporation for Atmospheric Research
 *   See netcdf/README file for copying and redistribution conditions.
 *   $Header: /u2/ldm/src/netcdf/nctest/RCS/misctests.c,v 1.2 89/10/30 14:24:44 russ Exp $
 *********************************************************************/

#include <stdio.h>
#include <string.h>
#include "netcdf.h"
#include "testcdf.h"		/* defines in-memory test cdf structure */

extern struct netcdf test;	/* keep in sync with disk netcdf */

extern void error();		/* prints error messages */

extern void add_reset();	/* functions to update in-memory netcdf */
extern void add_att();
extern void add_dim();
extern void add_var();


/*
 * Test nctypelen
 *    try with bad datatype, check error
 *    check returned values for each proper datatype
 */
void
test_nctypelen()
{
    static char pname[] = "test_nctypelen";

    (void) fprintf(stderr, "--- Testing %s ...\n", &pname[5]);

    if (nctypelen(NC_BYTE) != sizeof(char))
      error("%s: nctypelen failed for NC_BYTE", pname);
    if (nctypelen(NC_CHAR) != sizeof(char))
      error("%s: nctypelen failed for NC_CHAR", pname);
    if (nctypelen(NC_SHORT) != sizeof(short))
      error("%s: nctypelen failed for NC_SHORT", pname);
    if (nctypelen(NC_LONG) != sizeof(long))
      error("%s: nctypelen failed for NC_LONG", pname);
    if (nctypelen(NC_FLOAT) != sizeof(float))
      error("%s: nctypelen failed for NC_FLOAT", pname);
    if (nctypelen(NC_DOUBLE) != sizeof(double))
      error("%s: nctypelen failed for NC_DOUBLE", pname);
}


/*
 * Test nclink
 *    create a link with no data, close it, test that it can be opened
 *    overwrite an existing link (should be allowed to clobber links)
 *    try to overwrite an existing non-link netCDF, check error
 *    try to link to a non-existent netCDF, check error
 *    try with bad source handle, check error
 *    try with source netCDF in define mode, check error
 *    try with link netCDF in data mode, check error
 *    try with bad number of dimensions, check error
 *    try with bad dimension ids, check error
 *    try with bad dimension mins, check error
 *    try with bad dimension maxs, check error
 *    try with bad number of variables, check error
 *    try with bad variable ids, check error
 *    check that link and source netCDF agree on subset metadata, data
 */
    /* *** NOT DONE YET *** */
