/*
 *	Copyright 1988, University Corporation for Atmospheric Research
 *	    Not for Direct Resale. All copies to include this notice.
 */
#ifndef _LOCAL_NC_
#define _LOCAL_NC_
#ifndef	lint
/*SUPPRESS 287*/
static char rcsrev[] = 
	"$Id: local_nc.h,v 1.16 89/12/12 14:25:32 davis Exp Locker: davis $" ;
#endif	/* lint */
/*
 * Stellar 
 */
#define SYSTEM_XDR_INCLUDES

#ifdef DEBUG
#ifdef sun
#define	MDEBUG
#endif /* sun */
#endif /* DEBUG */

#ifdef sun
#define SYSTEM_XDR_INCLUDES
#endif

#ifdef vax
#define SWAP
#endif /* vax */

#ifdef MIPSEL	/* DECstation, a byte swapping MIPS processor */
#define SWAP
#endif /* MIPSEL */

#ifdef ultrix
#define SYSTEM_XDR_INCLUDES
#endif

#ifdef vms
#include	<unixio.h>
#endif /* vms */


#ifdef i386
#define SWAP
#endif /* i386 */


#ifdef MSDOS
#define SWAP
#define SYSTEM_XDR_INCLUDES		/* PC-NFS includes XDR */
#endif



#include	<stdio.h> 

#ifdef __STDC__ 	/* ANSI C compiler, */
#define STDC_ARGS /* Can use <stdarg.h> */
#define STDC_STRERROR /* has strerror() */
#define STDC_INCLUDES /* has conforming system include files  */
#endif

#ifdef vaxc 
#ifdef vms
/*
 *   Currently, vaxc on vms has the characteristics of an ANSI C compiler,
 * but does not define __STDC__
 * On ultrix, same problem as sun gcc (below).
 */
#define STDC_ARGS /* Can use <stdarg.h> */
#define STDC_STRERROR /* has strerror() */
#define STDC_INCLUDES /* has conforming system include files  */
#endif
#endif

/*
 * Currently there are situations where one has a compiler which
 * defines __STDC__ but the system doesn't have conforming libs
 * or include files - gcc or saber c on a sun or ultrix or vanilla unix.
 *   Sigh.
 */
#ifdef sun
/* #undef STDC_ARGS */
#undef STDC_STRERROR
#undef STDC_INCLUDES
#endif


#ifdef STDC_INCLUDES
#include <stddef.h>
#include <stdlib.h>
#define Size_t size_t
	/* "b" (binary) may/should be in the "mode" argument to fopen */
#define USE_BFLAG
#else
#ifndef NULL
#define	NULL	0
#endif /* NULL */
typedef unsigned Size_t; 
#endif

#ifndef FILENAME_MAX
#define FILENAME_MAX  255
#endif

#ifdef	SYSTEM_XDR_INCLUDES
#include	<rpc/rpc.h>
#else
#include	<types.h> /* "../xdr/types.h" */
#include	<xdr.h>	 /* "../xdr/xdr.h" */
#endif

/* Argument type in internal functions */
#define Void    char

#include	"netcdf.h"
#include	"error.h"

/*
 *	From here on out are 'private' data structures and objects
 */


/* like, a discriminated union in the sense of xdr */
typedef struct {
	nc_type type ;		/* the discriminant */
	Size_t len ;		/* the total length originally allocated */
	Size_t szof ;		/* sizeof each value */
	unsigned count ;	/* length of the array */
	Void *values ;		/* the actual data */
} NC_array ;

/* Counted string for names and such */
typedef struct {
	unsigned count ;
	char *values ;
} NC_string ;

/* Counted array of ints for assoc list */
typedef struct {
	unsigned count ;
	int *values ;
} NC_iarray ;

/* NC dimension stucture */
typedef struct {
	NC_string *name ;
	int size ;
} NC_dim ;

/* NC attribute */
typedef struct {
	NC_string	*name ;
	NC_array	*data ;
} NC_attr ;

/* NC variable: description and data */
typedef struct {
	NC_string *name ;
	NC_iarray *assoc ; /* user definition */
	unsigned *shape ; /* compiled info */
	unsigned *dsizes ; /* compiled info */
	NC_array *attrs;
	nc_type type ;		/* the discriminant */
	u_long len ;		/* the total length originally allocated */
	Size_t szof ;		/* sizeof each value */
	u_long begin ;  /* seek index */
} NC_var ;

#define IS_RECVAR(vp) \
	((vp)->shape != NULL ? (*(vp)->shape == NC_UNLIMITED) : 0 )

typedef struct {
	char path[FILENAME_MAX + 1] ;
	unsigned flags ;
	FILE *stream ;
	XDR *xdrs ;
	u_long begin_rec ; /* postion of the first 'record' */
	u_long recsize ; /* length of 'record' */
	/* below gets xdr'd */
	u_long numrecs ; /* number of 'records' allocated */
	NC_array *dims ;
	NC_array *attrs ;
	NC_array *vars ;
} NC ;

extern char *cdf_routine_name ; /* defined in lerror.c */

               /*  C D F 1 */
#define	NCMAGIC	0x43444601
                       /*  C D L 1 */
#define	NCLINKMAGIC	0x43444c01

#endif /* _LOCAL_NC_ */
